declare-option str markdown_formatcmd %{
    if dprint output-resolved-config >/dev/null 2>&1; then
        dprint fmt --stdin md
    else
        dprint fmt --stdin md --config "$HOME/.dprint.jsonc"
    fi
}
define-command markdown-fmt-impl %{
    evaluate-commands -draft -save-regs "fbs/l" %{
        set-register b %reg{percent}
        execute-keys -draft '%"fy'
        edit -scratch
        execute-keys '"fR'
        set-register s %reg{percent}
        set-register / '(?S)^\h*!\[.*\]\(.*\)$'
        execute-keys '%s<ret>"lyc<lt>!--𝅙--<gt><esc>'
        set-register | %opt{markdown_formatcmd}
        execute-keys '%|<ret>'
        set-register / '(?S)^\h*<!--𝅙-->'
        execute-keys '%s<ret>"lR%"fy'
        buffer %reg{b}
        delete-buffer %reg{s}
        execute-keys '%"fR'
    }
}

hook global WinSetOption filetype=markdown %{
    # explicitly load to avoid race condition
    set-option window comment_line ''
    set-option window comment_block_begin '<!--'
    set-option window comment_block_end '-->'

    require-module markdown
	set-option window formatcmd %{
        if dprint output-resolved-config >/dev/null 2>&1; then
            dprint fmt --stdin md
        else
            dprint fmt --stdin md --config "$HOME/.dprint.jsonc"
        fi
	}
	hook -group markdown-auto-format window BufWritePre .* { markdown-fmt-impl }
	map window normal = ': markdown-fmt-impl<ret>'

    # override formatting commands
    define-command -override -hidden markdown-trim-indent %{
        evaluate-commands -no-hooks -draft -itersel %{
            execute-keys x
            # remove trailing white spaces
            # try %{ execute-keys -draft s \h + $ <ret> d }
        }
    }

    define-command -override -hidden markdown-insert-on-new-line %{
        try %{ execute-keys -draft -itersel k x s ^\h*\K((>\h*)+([*+-]\h)?|(>\h*)*[*+-]\h)\h* <ret> y gh j P }
    }

    define-command -override -hidden markdown-indent-on-new-line %{
        evaluate-commands -draft -itersel %{
            # preserve previous line indent
            try %{ execute-keys -draft <semicolon> K <a-&> }
            # remove trailing white spaces
            # try %{ execute-keys -draft k x s \h+$ <ret> d }
        }
    }


	# hook -once -always WinSetOption filetype=.* %{
	# 	unset-option window formatcmd
	# 	remove-hooks window markdown-auto-format
	# }
}
